-module(eensy@otp@task).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([async/1, try_await/2, await/2]).
-export_type([task/1, await_error/0, message/1]).

-opaque task(GVF) :: {task,
        gleam@erlang@process:pid_(),
        gleam@erlang@process:pid_(),
        gleam@erlang@process:process_monitor(),
        gleam@erlang@process:selector(message(GVF))}.

-type await_error() :: timeout | {exit, gleam@dynamic:dynamic_()}.

-type message(GVG) :: {from_monitor, gleam@erlang@process:process_down()} |
    {from_subject, GVG}.

-file("/Users/raynerdls/ray.delossantos/apps/eensy-repos/packages/eensy/src/eensy/otp/task.gleam", 51).
-spec async(fun(() -> GVH)) -> task(GVH).
async(Work) ->
    Owner = erlang:self(),
    Subject = gleam@erlang@process:new_subject(),
    Pid = gleam@erlang@process:start(
        fun() -> gleam@erlang@process:send(Subject, Work()) end,
        true
    ),
    Monitor = gleam@erlang@process:monitor_process(Pid),
    Selector = begin
        _pipe = gleam_erlang_ffi:new_selector(),
        _pipe@1 = gleam@erlang@process:selecting_process_down(
            _pipe,
            Monitor,
            fun(Field@0) -> {from_monitor, Field@0} end
        ),
        gleam@erlang@process:selecting(
            _pipe@1,
            Subject,
            fun(Field@0) -> {from_subject, Field@0} end
        )
    end,
    {task, Owner, Pid, Monitor, Selector}.

-file("/Users/raynerdls/ray.delossantos/apps/eensy-repos/packages/eensy/src/eensy/otp/task.gleam", 71).
-spec assert_owner(task(any())) -> nil.
assert_owner(Task) ->
    Self = erlang:self(),
    case erlang:element(2, Task) =:= Self of
        true ->
            nil;

        false ->
            gleam@erlang@process:send_abnormal_exit(
                Self,
                <<"awaited on a task that does not belong to this process"/utf8>>
            )
    end.

-file("/Users/raynerdls/ray.delossantos/apps/eensy-repos/packages/eensy/src/eensy/otp/task.gleam", 94).
-spec try_await(task(GVL), integer()) -> {ok, GVL} | {error, await_error()}.
try_await(Task, Timeout) ->
    assert_owner(Task),
    case gleam_erlang_ffi:select(erlang:element(5, Task), Timeout) of
        {ok, {from_subject, X}} ->
            gleam_erlang_ffi:demonitor(erlang:element(4, Task)),
            {ok, X};

        {ok, {from_monitor, {process_down, _, Reason}}} ->
            {error, {exit, Reason}};

        {error, nil} ->
            {error, timeout}
    end.

-file("/Users/raynerdls/ray.delossantos/apps/eensy-repos/packages/eensy/src/eensy/otp/task.gleam", 118).
-spec await(task(GVP), integer()) -> GVP.
await(Task, Timeout) ->
    _assert_subject = try_await(Task, Timeout),
    {ok, Value} = case _assert_subject of
        {ok, _} -> _assert_subject;
        _assert_fail ->
            erlang:error(#{gleam_error => let_assert,
                        message => <<"Pattern match failed, no pattern matched the value."/utf8>>,
                        value => _assert_fail,
                        module => <<"eensy/otp/task"/utf8>>,
                        function => <<"await"/utf8>>,
                        line => 119})
    end,
    Value.
